// Copyright 2005-2011, FreeHEP.
package hep.wired.cut;

import javax.swing.JPanel;
import javax.swing.event.ChangeListener;

/**
 * Base class for condition editors.
 *
 * @author Dmitry Onoprienko
 * @version $Id: $
 */
abstract public class ConditionEditor implements ChangeListener {

// -- Private parts : ----------------------------------------------------------

  protected Condition _condition;


// -- Setters : ----------------------------------------------------------------

  /**
   * Sets Condition to be edited.
   * If called with null argument, resets the editor, eliminating any references
   * to previously edited condition.
   */
  public void setCondition(Condition condition) {
    if (condition != _condition) {
      if (_condition != null) {
        _condition.getDefinition().removeChangeListener(this);
      }
      _condition = condition;
      if (_condition != null) {
        _condition.getDefinition().addChangeListener(this);
      }
    }
  }


// -- Getters : ----------------------------------------------------------------

  /** Returns Condition being edited. */
  public Condition getCondition() {
    return _condition;
  }

  /** Returns the type of condition handled by this editor. */
  public ConditionDefinition.Type getType() {
    return getCondition().getDefinition().getType();
  }

  /** Returns GUI for this editor. */
  abstract public JPanel getPanel();

}
