// Copyright 2004, FreeHEP.
package hep.wired.edit;

import hep.wired.services.Edit;
import hep.wired.services.GraphicsPanel;

/**
 * Interface for edits handled by changing the graphics panel.
 * 
 * @author Mark Donszelmann
 * @version $Id: GraphicsPanelEdit.java 8598 2006-08-14 20:38:02Z duns $
 */

public interface GraphicsPanelEdit extends Edit {

    /**
     * Returns true if this edit is supported by the given graphics panel.
     * 
     * @param graphicsPanel panel by which this edit will be handled.
     * @return true if the edit is supported.
     */
    public boolean isSupportedBy(GraphicsPanel graphicsPanel);
}
