// Copyright 2003-2006, FreeHEP.
package hep.wired.interaction;

import hep.wired.services.GraphicsPanel;
import hep.wired.services.RecordPlot;

import java.awt.Cursor;
import java.awt.event.InputEvent;
import java.awt.event.MouseEvent;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: NullInteractionHandler.java 8598 2006-08-14 20:38:02Z duns $
 */
public class NullInteractionHandler extends AbstractInteractionHandler {

    private static NullInteractionHandler instance;

    protected NullInteractionHandler() {
        super("No Interaction");
    }

    public static NullInteractionHandler getInstance() {
        if (instance == null) {
            instance = new NullInteractionHandler();
        }
        return instance;
    }

    public String getDescription() {
        return "No Interaction.";
    }

    public boolean isSupportedBy(GraphicsPanel panel) {
        return true;
    }

    public void changeCursor(RecordPlot plot, InputEvent event) {
        plot.setCursor(Cursor.getDefaultCursor());
    }

    public void mouseEntered(RecordPlot plot, MouseEvent event) {
        plot.requestFocusInWindow();
        changeCursor(plot, event);
    }
}
