// Copyright 2004, FreeHEP.
package hep.wired.plugin;


/**
 * Defines a XMLIO factory for a set of classes.
 * 
 * @author Mark Donszelmann
 * @version $Id: WiredXMLIOFactory.java 8598 2006-08-14 20:38:02Z duns $
 */
public class WiredXMLIOFactory extends AbstractXMLIOFactory {

    private Class[] cls;

    public WiredXMLIOFactory(Class cls) {
        this.cls = new Class[] { cls };
    }

    public Class[] XMLIOFactoryClasses() {
        return cls;
    }

    public boolean equals(Object obj) {
        if (obj instanceof WiredXMLIOFactory) {
            return cls[0].equals(obj);
        }
        return super.equals(obj);
    }

    public int hashCode() {
        return cls[0].hashCode();
    }
}
