// Copyright 2003-2004, FreeHEP.
package hep.wired.services;

import javax.swing.JPopupMenu;

/**
 * Interface for panel to display.
 * 
 * @author Mark Donszelmann
 * @version $Id: GraphicsPanel.java 8598 2006-08-14 20:38:02Z duns $
 */

public interface GraphicsPanel {

    /**
     * Returns a copy of this graphics panel.
     */
    public GraphicsPanel copy();

    /**
     * Sets the Record to be displayed in this panel.
     */
    public void setRecord(Object record);

    /**
     * Returns the Record displayed in this panel.
     */
    public Object getRecord();

    /**
     * Return true if feature is available
     */
    public boolean supports(Class featureClass);

    /**
     * Returns the feature if available
     */
    public Feature getFeature(Class featureClass);

    /**
     * Returns the viewport for this panel.
     */
    public ViewPort getViewPort();

    /**
     * Allows for modification of the popup menu
     */
    public JPopupMenu modifyPopupMenu(JPopupMenu menu, RecordPlot plot);

    /**
     * Switches to a fast mode for drawing (optional).
     */
    public void setFastMode(boolean fast);

    /**
     * Designates the panel as selected.
     */
    public void setSelected(RecordPlot plot, boolean selected);

}
