package hep.wired.util.tree;

import javax.swing.tree.DefaultTreeSelectionModel;
import javax.swing.tree.TreePath;

/**
 *
 * @author Dmitry Onoprienko
 * @version $Id: $
 */
public class WiredTreeSelectionModel extends DefaultTreeSelectionModel {

// -- Private parts : ----------------------------------------------------------

// -- Constructors : -----------------------------------------------------------

// -- Overriding adding/removing paths to selection : --------------------------

  public void addSelectionPath(TreePath path) {
    addSelectionPaths(path == null ? null : new TreePath[] {path});
  }

  public void addSelectionPaths(TreePath[] paths) {
    if (paths != null) {
      for (TreePath path : paths) {
        if (path != null) ((WiredTreeNode) path.getLastPathComponent()).setSelected(true);
      }
    }
    super.addSelectionPaths(paths);
  }

  public void clearSelection() {
     removeSelectionPaths(getSelectionPaths());
  }

  public void removeSelectionPath(TreePath path) {
    removeSelectionPaths(path == null ? null : new TreePath[] {path});
  }

  public void removeSelectionPaths(TreePath[] paths) {
    if (paths != null) {
      for (TreePath path : paths) {
        if (path != null) ((WiredTreeNode) path.getLastPathComponent()).setSelected(false);
      }
    }
    super.removeSelectionPaths(paths);
  }

  public void setSelectionPath(TreePath path) {
    setSelectionPaths(path == null ? null : new TreePath[] {path});
  }

  public void setSelectionPaths(TreePath[] paths) {
    TreePath[] pp = getSelectionPaths();
    if (pp != null) {
      for (TreePath p : pp) {
        ((WiredTreeNode) p.getLastPathComponent()).setSelected(false);
      }
    }
    for (TreePath path : paths) {
      if (path != null) ((WiredTreeNode) path.getLastPathComponent()).setSelected(true);
    }
    super.setSelectionPaths(paths);
  }

// -----------------------------------------------------------------------------
}
