package hep.wired.util.tree.test;

import hep.wired.util.tree.BranchCheckBox;
import java.awt.GridLayout;
import java.awt.event.ActionListener;
import javax.swing.JCheckBox;
import javax.swing.JFrame;
import javax.swing.UIManager;

/**
 *
 * @author Dmitry Onoprienko
 * @version $Id: $
 */
public class BranchCheckBoxTest {

  public static void main(String args[]) throws Exception {
    try {
      String plaf = UIManager.getSystemLookAndFeelClassName();
      UIManager.setLookAndFeel(plaf);
    } catch (Exception e) {
      System.out.println("Error loading Look and Feel");
    }
    JFrame frame = new JFrame("Test");
    frame.setLayout(new GridLayout(0, 3, 15, 15));
    frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

    final BranchCheckBox cb = new BranchCheckBox();

    final JCheckBox b = new JCheckBox("Branch is completely visible.", cb.isBranchComplete());
    b.addActionListener(new ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent event) {
        cb.setBranchComplete(b.isSelected());
      }
    });

    final JCheckBox e = new JCheckBox("Enabled.", true);
    e.addActionListener(new ActionListener() {
      public void actionPerformed(java.awt.event.ActionEvent event) {
        cb.setEnabled(e.isSelected());
      }
    });

    frame.add(cb);
    frame.add(b);
    frame.add(e);
    frame.pack();
    frame.setVisible(true);
  }
}
