// Copyright 2004-2005, FreeHEP.
package hep.wired.variable;

import hep.wired.util.slider.BoundedIntegerRangeModel;
import hep.wired.util.slider.DefaultBoundedIntegerRangeModel;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: IntegerVariableSliderModel.java 8598 2006-08-14 20:38:02Z duns $
 */
public class IntegerVariableSliderModel extends VariableSliderModel implements BoundedIntegerRangeModel {

    public IntegerVariableSliderModel() {
        this(null);
    }

    public IntegerVariableSliderModel(IntegerVariable variable) {
        super(variable);
    }
 
    public int getValue() {
        return variable != null ? ((IntegerVariable)variable).getIntegerVariable() : 0;
    }

    public int getMinimum() {
        return variable != null ? ((IntegerVariable)variable).getMinimum() : 0;
    }
    
    public int getMaximum() {
        return variable != null ? ((IntegerVariable)variable).getMaximum() : 100;
    }
    
    public int getDefaultValue() {
        return variable != null ? ((IntegerVariable)variable).getDefault() : 0;
    }
    
    public void setValue(int value) {
        if (variable != null) ((IntegerVariable)variable).setVariable(value);
    }

    public void setRangeProperties(int newValue, int newExtent, 
                                   int newMin, int newMax, 
                                   int newDef, boolean newAdjusting) {
        boolean fire = DefaultBoundedIntegerRangeModel.rangePropertiesChanged(this, 
                            newValue, newExtent, newMin, newMax, newDef, newAdjusting);
        
        if (fire) {
            setValue(newValue);
            fireStateChanged();
        }
    }
    
    public void setMinimum(int minimum) {
        // ignored
    }

    public void setMaximum(int maximum) {
        // ignored
    }

    public int getExtent() {
        // ignored
        return 0;
    }

    public void setExtent(int extent) {
        // ignored
    }

    public void setDefaultValue(int def) {
        // ignored
    }

    public Number getNumber() {
        return new Integer(getValue());
    }

    public Number getDefaultNumber() {
        return new Integer(getDefaultValue());
    }

    public void resetValue() {
        setValue(getDefaultValue());
    }

    public void setValue(String number) throws NumberFormatException {
        setValue(Integer.parseInt(number));
    }
}
