// Copyright 2005, FreeHEP.
package hep.wired.variable;

/**
 * 
 * @author Mark Donszelmann
 * @version $Id: NumberVariable.java 8598 2006-08-14 20:38:02Z duns $
 */

public abstract class NumberVariable extends AbstractVariable {

    public NumberVariable(String name, Object object, String unit,
            String description) {
        super(name, object, unit, description);
    }

    public int compareTo(Object o) {
        if (o instanceof NumberVariable) {
            NumberVariable n = (NumberVariable) o;
            double d1 = ((Number) getValue()).doubleValue();
            double d2 = ((Number) n.getValue()).doubleValue();
            return d1 < d2 ? -1 : d1 == d2 ? 0 : 1;
        }
        // Double, Int, Boolean
        return this instanceof DoubleVariable ? -1
                : o instanceof BooleanVariable ? -1 : 1;
    }
}
